/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 2023 Roger Hale, Ben Moszkowski,
 * Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
/* 
 * sample of conversions between the various datatypes
 */

/* run */ define test_1() = {
  exists X: {
   X = 42 and
   output(X) and
   output(itompz(X)) and
   output(itof(X)) and
   output(itompx(X)) and
   output(itompfr(X)) and
   output(itostr(X)) and
   empty
 }
}.

/*
fl_rnd:
0: FE_TONEAREST, rint almost equivalent to round, halfway cases
                 are rounded to even rather than away from zero
1: FE_DOWNWARD, rint equivalent to floor
2: FE_UPWARD, rint equivalent to ceil
3: FE_TOWARDZERO, rint equivalent to trunc
 */
/* run */ define test_2() = {
  exists X: {
   X = $3.14$ and set fl_rnd = 0 and
   output(X) and
   output(rint(X)) and
   output(itompz(rint(X))) and
   output(itompx(rint(X))) and
   output(fltompfr(X)) and
   output(fltostr(X)) and
   empty
 }
}.

/* run */ define test_3() = {
  exists X: {
   X = 0z42 and
   output(X) and
   output(mpztoi(X)) and
   output(mpztompx(X)) and
   output(mpztompfr(X)) and
   output(mpfrtofl(mpztompfr(X))) and
   output(mpztostr(X)) and
   empty
 }
}.

/* run */ define test_4() = {
  exists X: {
   X = 0x2a and
   output(X) and
   output(mpxtoi(X)) and
   output(mpxtompz(X)) and
   output(mpxtompfr(X)) and
   output(mpfrtofl(mpxtompfr(X))) and
   output(mpxtostr(X)) and
   empty
 }
}.

/*
mpfr_rnd:
0: MPFR_RNDN, rint = roundeven
1: MPFR_RNDD, rint = floor
2: MPFR_RNDU, rint = ceil
3: MPFR_RNDZ, rint = trunc
4: MPFR_RNDA, rint = round
5: MPFR_RNDF, 
*/
/* run */ define test_5() = {
  exists X: {
   X = $$3.49$$ and set mpfr_rnd = 0 and
   output(X) and
   output(rint(X)) and
   output(mpztompx(rint(X))) and
   output(mpfrtofl(X)) and
   output(mpfrtostr(X)) and
   empty
 }
}.

/* run */ define test_6() = {
  exists X: {
   {X = "42" and
    output(X) and
    output(strtoi(X)) and
    empty};skip;
   {X = "0z42" and
    output(X) and
    output(strtompz(X)) and
    empty};skip;
   {X = "0x2a" and
    output(X) and
    output(strtompx(X)) and
    empty};skip;
   {X = "$3.14$" and
    output(X) and
    output(strtofl(X)) and
    empty};skip;
   {X = "$$3.14$$" and
    output(X) and
    output(strtompfr(X)) and
    empty}
 }
}.

