/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 2023 Roger Hale, Ben Moszkowski,
 * Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
/* 
 * test of 'forall e in L : { } and 'exists e in L : { }' 
 */

/* run */ define test_1() = {
  exists L : {
   L = [1,2,3] and
   forall e in L : { output e } and empty
 }
}.

/* run */ define test_2() = {
  exists L: {
   L=[1,2,3] and
   format(" L = %t  and (forall i<|L| : ( L[i] < 4 ) ) = %t\n", L,  
    (forall i<|L| : ( L[i] < 4 ) ) ) and
   empty
 }
}.


/* run */ define test_3() = {
  exists L: {
   L = [1,2,3] and
   format(" L = %t  and (forall e in L : ( e < 4 ) ) = %t\n",L,
          (forall e in L : ( e < 4 ) ) ) and 
   empty
 }
}.

/* run */ define test_4() = {
  exists L: {
   L = [1,2,4] and
   format(" L = %t  and (forall e in L : ( e < 4 ) ) = %t\n",L,
          (forall e in L : ( e < 4 ) ) ) and
   empty
 }
}.


/* run */ define test_5() = {
  exists L : {
   L = [1,2,3] and
   format(" L = %t  and (exists i <|L| : ( L[i] = 3 ) ) = %t\n",L,
          (exists i <|L| : ( L[i] = 3 ) ) ) and
   empty
 }
}.

/* run */ define test_6() = {
  exists L : {
   L = [1,2,3] and
   format(" L = %t  and (exists e in L : ( e = 3 ) ) = %t\n", L,
          (exists e in L : ( e = 3 ) ) ) and
   empty
  }
 }.

/* run */ define test_7() = {
  exists L : {
   L = [1,2,3] and
   format(" L = %t  and (exists e in L : ( e = 4 ) ) = %t\n", L,
          (exists e in L : ( e = 4 ) ) ) and
   empty
 }
}.

/* run */ define test_8() = {
  exists L : {
   L = [] and
   format(" L = %t  and (exists e in L : ( e = 42 ) ) = %t\n", L,
          (exists e in L : ( e = 42 ) ) ) and
   empty
 }
}.

/* run */ define test_9() = {
  exists L : {
   L = [] and
   format(" L = %t  and (forall e in L : ( e = 42 ) ) = %t\n", L,
          (forall e in L : ( e = 42 ) ) ) and
   empty
 }
}.




